Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | List of all members
faiss::LinearTransform Struct Reference

`#include <VectorTransform.h>`

Inheritance diagram for faiss::LinearTransform:

## Public Member Functions
| LinearTransform (int d_in=0, int d_out=0, bool have_bias=false)
| both d_in > d_out and d_out < d_in are supported
void | apply_noalloc (idx_t n, const float *x, float *xt) const override
| same as apply, but result is pre-allocated
void | transform_transpose (idx_t n, const float *y, float *x) const
void | reverse_transform (idx_t n, const float *xt, float *x) const override
| works only if is_orthonormal
void | set_is_orthonormal ()
| compute A^T * A to set the is_orthonormal flag
Public Member Functions inherited from faiss::VectorTransform
| VectorTransform (int d_in=0, int d_out=0)
| ! output dimension
virtual void | train (idx_t n, const float *x)
float * | apply (idx_t n, const float *x) const

## Public Attributes
bool | have_bias
bool | is_orthonormal
| ! whether to use the bias term More...
std::vector< float > | A
| Transformation matrix, size d_out * d_in.
std::vector< float > | b
| bias vector, size d_out
bool | verbose
Public Attributes inherited from faiss::VectorTransform
int | d_in
int | d_out
| ! input dimension
bool | is_trained

## Additional Inherited Members
Public Types inherited from faiss::VectorTransform
typedef Index::idx_t | idx_t

## Detailed Description

Generic linear transformation, with bias term applied on output y = A * x + b

Definition at line 77 of file VectorTransform.h.

## Member Function Documentation

void LinearTransform::transform_transpose | ( | idx_t | n,
|  | const float * | y,
|  | float * | x
| ) |  | const

compute x = A^T * (x - b) is reverse transform if A has orthonormal lines

Definition at line 135 of file VectorTransform.cpp.

## Member Data Documentation

bool faiss::LinearTransform::is_orthonormal

! whether to use the bias term

check if matrix A is orthonormal (enables reverse_transform)

Definition at line 82 of file VectorTransform.h.

The documentation for this struct was generated from the following files:

- /data/users/matthijs/github_faiss/faiss/VectorTransform.h
- /data/users/matthijs/github_faiss/faiss/VectorTransform.cpp